/* time.c generated by valac 0.20.1, the Vala compiler
 * generated from time.vala, do not modify */

/*
 *  This file is part of Netsukuku.
 *  (c) Copyright 2011 Luca Dionisi aka lukisi <luca.dionisi@gmail.com>
 *
 *  Netsukuku is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Netsukuku is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Netsukuku.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define TASKLETS_TYPE_TIMER (tasklets_timer_get_type ())
#define TASKLETS_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TASKLETS_TYPE_TIMER, TaskletsTimer))
#define TASKLETS_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TASKLETS_TYPE_TIMER, TaskletsTimerClass))
#define TASKLETS_IS_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TASKLETS_TYPE_TIMER))
#define TASKLETS_IS_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TASKLETS_TYPE_TIMER))
#define TASKLETS_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TASKLETS_TYPE_TIMER, TaskletsTimerClass))

typedef struct _TaskletsTimer TaskletsTimer;
typedef struct _TaskletsTimerClass TaskletsTimerClass;
typedef struct _TaskletsTimerPrivate TaskletsTimerPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TaskletsTimer {
	GObject parent_instance;
	TaskletsTimerPrivate * priv;
	GTimeVal exp;
};

struct _TaskletsTimerClass {
	GObjectClass parent_class;
};


static gpointer tasklets_timer_parent_class = NULL;

void tasklets_ms_wait (gint64 msec);
void tasklets_tasklet_nap (glong sec, glong usec);
GType tasklets_timer_get_type (void) G_GNUC_CONST;
enum  {
	TASKLETS_TIMER_DUMMY_PROPERTY
};
TaskletsTimer* tasklets_timer_new (gint64 msec_ttl);
TaskletsTimer* tasklets_timer_construct (GType object_type, gint64 msec_ttl);
void tasklets_timer_set_time (TaskletsTimer* self, gint64 msec_ttl);
gint64 tasklets_timer_get_msec_ttl (TaskletsTimer* self);
gboolean tasklets_timer_is_younger (TaskletsTimer* self, TaskletsTimer* t);
gboolean tasklets_timer_is_expired (TaskletsTimer* self);
gchar* tasklets_timer_get_string_msec_ttl (TaskletsTimer* self);
static void tasklets_timer_finalize (GObject* obj);


void tasklets_ms_wait (gint64 msec) {
	gint64 _tmp0_;
	gint64 sec;
	gint64 _tmp1_;
	gint64 undersec;
	gint64 usec;
#line 25 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp0_ = msec;
#line 25 "/home/luca/repo/wip/tasklet/time.vala"
	sec = _tmp0_ / ((gint64) 1000);
#line 26 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp1_ = msec;
#line 26 "/home/luca/repo/wip/tasklet/time.vala"
	undersec = _tmp1_ - (sec * ((gint64) 1000));
#line 27 "/home/luca/repo/wip/tasklet/time.vala"
	usec = undersec * ((gint64) 1000);
#line 28 "/home/luca/repo/wip/tasklet/time.vala"
	tasklets_tasklet_nap ((glong) sec, (glong) usec);
#line 88 "time.c"
}


TaskletsTimer* tasklets_timer_construct (GType object_type, gint64 msec_ttl) {
	TaskletsTimer * self = NULL;
	gint64 _tmp0_;
#line 36 "/home/luca/repo/wip/tasklet/time.vala"
	self = (TaskletsTimer*) g_object_new (object_type, NULL);
#line 38 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp0_ = msec_ttl;
#line 38 "/home/luca/repo/wip/tasklet/time.vala"
	tasklets_timer_set_time (self, _tmp0_);
#line 36 "/home/luca/repo/wip/tasklet/time.vala"
	return self;
#line 103 "time.c"
}


TaskletsTimer* tasklets_timer_new (gint64 msec_ttl) {
#line 36 "/home/luca/repo/wip/tasklet/time.vala"
	return tasklets_timer_construct (TASKLETS_TYPE_TIMER, msec_ttl);
#line 110 "time.c"
}


void tasklets_timer_set_time (TaskletsTimer* self, gint64 msec_ttl) {
	gint64 _tmp0_;
	glong milli;
	gint64 _tmp1_;
	glong seconds;
	GTimeVal _tmp2_;
	glong _tmp3_;
	gint64 check_seconds;
	gint64 _tmp4_;
	gint64 _tmp5_;
	glong _tmp6_;
	glong _tmp7_;
#line 41 "/home/luca/repo/wip/tasklet/time.vala"
	g_return_if_fail (self != NULL);
#line 43 "/home/luca/repo/wip/tasklet/time.vala"
	g_get_current_time (&self->exp);
#line 44 "/home/luca/repo/wip/tasklet/time.vala"
	g_get_current_time (&self->exp);
#line 45 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp0_ = msec_ttl;
#line 45 "/home/luca/repo/wip/tasklet/time.vala"
	milli = (glong) (_tmp0_ % ((gint64) 1000));
#line 46 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp1_ = msec_ttl;
#line 46 "/home/luca/repo/wip/tasklet/time.vala"
	seconds = (glong) (_tmp1_ / ((gint64) 1000));
#line 47 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp2_ = self->exp;
#line 47 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp3_ = _tmp2_.tv_sec;
#line 47 "/home/luca/repo/wip/tasklet/time.vala"
	check_seconds = (gint64) _tmp3_;
#line 48 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp4_ = check_seconds;
#line 48 "/home/luca/repo/wip/tasklet/time.vala"
	check_seconds = _tmp4_ + ((gint64) seconds);
#line 49 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp5_ = check_seconds;
#line 49 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp6_ = G_MAXLONG;
#line 49 "/home/luca/repo/wip/tasklet/time.vala"
	_vala_assert (_tmp5_ <= ((gint64) _tmp6_), "check_seconds <= long.MAX");
#line 50 "/home/luca/repo/wip/tasklet/time.vala"
	g_time_val_add (&self->exp, milli * 1000);
#line 51 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp7_ = self->exp.tv_sec;
#line 51 "/home/luca/repo/wip/tasklet/time.vala"
	self->exp.tv_sec = _tmp7_ + seconds;
#line 162 "time.c"
}


gint64 tasklets_timer_get_msec_ttl (TaskletsTimer* self) {
	gint64 result = 0LL;
	GTimeVal now = {0};
	GTimeVal _tmp0_;
	glong _tmp1_;
	GTimeVal _tmp2_;
	glong _tmp3_;
	glong sec;
	GTimeVal _tmp4_;
	glong _tmp5_;
	GTimeVal _tmp6_;
	glong _tmp7_;
	glong usec;
	glong _tmp11_;
	glong _tmp12_;
#line 54 "/home/luca/repo/wip/tasklet/time.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 61 "/home/luca/repo/wip/tasklet/time.vala"
	g_get_current_time (&now);
#line 62 "/home/luca/repo/wip/tasklet/time.vala"
	g_get_current_time (&now);
#line 63 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp0_ = self->exp;
#line 63 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp1_ = _tmp0_.tv_sec;
#line 63 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp2_ = now;
#line 63 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp3_ = _tmp2_.tv_sec;
#line 63 "/home/luca/repo/wip/tasklet/time.vala"
	sec = _tmp1_ - _tmp3_;
#line 64 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp4_ = self->exp;
#line 64 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp5_ = _tmp4_.tv_usec;
#line 64 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp6_ = now;
#line 64 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp7_ = _tmp6_.tv_usec;
#line 64 "/home/luca/repo/wip/tasklet/time.vala"
	usec = _tmp5_ - _tmp7_;
#line 65 "/home/luca/repo/wip/tasklet/time.vala"
	while (TRUE) {
#line 209 "time.c"
		glong _tmp8_;
		glong _tmp9_;
		glong _tmp10_;
#line 65 "/home/luca/repo/wip/tasklet/time.vala"
		_tmp8_ = usec;
#line 65 "/home/luca/repo/wip/tasklet/time.vala"
		if (!(_tmp8_ < ((glong) 0))) {
#line 65 "/home/luca/repo/wip/tasklet/time.vala"
			break;
#line 219 "time.c"
		}
#line 67 "/home/luca/repo/wip/tasklet/time.vala"
		_tmp9_ = usec;
#line 67 "/home/luca/repo/wip/tasklet/time.vala"
		usec = _tmp9_ + 1000000;
#line 68 "/home/luca/repo/wip/tasklet/time.vala"
		_tmp10_ = sec;
#line 68 "/home/luca/repo/wip/tasklet/time.vala"
		sec = _tmp10_ - 1;
#line 229 "time.c"
	}
#line 70 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp11_ = sec;
#line 70 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp12_ = usec;
#line 70 "/home/luca/repo/wip/tasklet/time.vala"
	result = (((gint64) _tmp11_) * ((gint64) 1000)) + (((gint64) _tmp12_) / ((gint64) 1000));
#line 70 "/home/luca/repo/wip/tasklet/time.vala"
	return result;
#line 239 "time.c"
}


gboolean tasklets_timer_is_younger (TaskletsTimer* self, TaskletsTimer* t) {
	gboolean result = FALSE;
	GTimeVal _tmp0_;
	glong _tmp1_;
	TaskletsTimer* _tmp2_;
	GTimeVal _tmp3_;
	glong _tmp4_;
	GTimeVal _tmp5_;
	glong _tmp6_;
	TaskletsTimer* _tmp7_;
	GTimeVal _tmp8_;
	glong _tmp9_;
	GTimeVal _tmp10_;
	glong _tmp11_;
	TaskletsTimer* _tmp12_;
	GTimeVal _tmp13_;
	glong _tmp14_;
#line 73 "/home/luca/repo/wip/tasklet/time.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "/home/luca/repo/wip/tasklet/time.vala"
	g_return_val_if_fail (t != NULL, FALSE);
#line 75 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp0_ = self->exp;
#line 75 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp1_ = _tmp0_.tv_sec;
#line 75 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp2_ = t;
#line 75 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp3_ = _tmp2_->exp;
#line 75 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp4_ = _tmp3_.tv_sec;
#line 75 "/home/luca/repo/wip/tasklet/time.vala"
	if (_tmp1_ > _tmp4_) {
#line 75 "/home/luca/repo/wip/tasklet/time.vala"
		result = TRUE;
#line 75 "/home/luca/repo/wip/tasklet/time.vala"
		return result;
#line 280 "time.c"
	}
#line 76 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp5_ = self->exp;
#line 76 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp6_ = _tmp5_.tv_sec;
#line 76 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp7_ = t;
#line 76 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp8_ = _tmp7_->exp;
#line 76 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp9_ = _tmp8_.tv_sec;
#line 76 "/home/luca/repo/wip/tasklet/time.vala"
	if (_tmp6_ < _tmp9_) {
#line 76 "/home/luca/repo/wip/tasklet/time.vala"
		result = FALSE;
#line 76 "/home/luca/repo/wip/tasklet/time.vala"
		return result;
#line 298 "time.c"
	}
#line 77 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp10_ = self->exp;
#line 77 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp11_ = _tmp10_.tv_usec;
#line 77 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp12_ = t;
#line 77 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp13_ = _tmp12_->exp;
#line 77 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp14_ = _tmp13_.tv_usec;
#line 77 "/home/luca/repo/wip/tasklet/time.vala"
	if (_tmp11_ > _tmp14_) {
#line 77 "/home/luca/repo/wip/tasklet/time.vala"
		result = TRUE;
#line 77 "/home/luca/repo/wip/tasklet/time.vala"
		return result;
#line 316 "time.c"
	}
#line 78 "/home/luca/repo/wip/tasklet/time.vala"
	result = FALSE;
#line 78 "/home/luca/repo/wip/tasklet/time.vala"
	return result;
#line 322 "time.c"
}


gboolean tasklets_timer_is_expired (TaskletsTimer* self) {
	gboolean result = FALSE;
	gint64 _tmp0_ = 0LL;
#line 81 "/home/luca/repo/wip/tasklet/time.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 83 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp0_ = tasklets_timer_get_msec_ttl (self);
#line 83 "/home/luca/repo/wip/tasklet/time.vala"
	result = _tmp0_ < ((gint64) 0);
#line 83 "/home/luca/repo/wip/tasklet/time.vala"
	return result;
#line 337 "time.c"
}


gchar* tasklets_timer_get_string_msec_ttl (TaskletsTimer* self) {
	gchar* result = NULL;
	gint64 _tmp0_ = 0LL;
	gchar* _tmp1_ = NULL;
#line 86 "/home/luca/repo/wip/tasklet/time.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 88 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp0_ = tasklets_timer_get_msec_ttl (self);
#line 88 "/home/luca/repo/wip/tasklet/time.vala"
	_tmp1_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp0_);
#line 88 "/home/luca/repo/wip/tasklet/time.vala"
	result = _tmp1_;
#line 88 "/home/luca/repo/wip/tasklet/time.vala"
	return result;
#line 355 "time.c"
}


static void tasklets_timer_class_init (TaskletsTimerClass * klass) {
#line 33 "/home/luca/repo/wip/tasklet/time.vala"
	tasklets_timer_parent_class = g_type_class_peek_parent (klass);
#line 33 "/home/luca/repo/wip/tasklet/time.vala"
	G_OBJECT_CLASS (klass)->finalize = tasklets_timer_finalize;
#line 364 "time.c"
}


static void tasklets_timer_instance_init (TaskletsTimer * self) {
}


static void tasklets_timer_finalize (GObject* obj) {
	TaskletsTimer * self;
#line 33 "/home/luca/repo/wip/tasklet/time.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TASKLETS_TYPE_TIMER, TaskletsTimer);
#line 33 "/home/luca/repo/wip/tasklet/time.vala"
	G_OBJECT_CLASS (tasklets_timer_parent_class)->finalize (obj);
#line 378 "time.c"
}


/** Class for "timeouts" or "timespans"
      */
GType tasklets_timer_get_type (void) {
	static volatile gsize tasklets_timer_type_id__volatile = 0;
	if (g_once_init_enter (&tasklets_timer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TaskletsTimerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tasklets_timer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TaskletsTimer), 0, (GInstanceInitFunc) tasklets_timer_instance_init, NULL };
		GType tasklets_timer_type_id;
		tasklets_timer_type_id = g_type_register_static (G_TYPE_OBJECT, "TaskletsTimer", &g_define_type_info, 0);
		g_once_init_leave (&tasklets_timer_type_id__volatile, tasklets_timer_type_id);
	}
	return tasklets_timer_type_id__volatile;
}



